// QOverDlg.cpp: QOverDlg NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////
#include "qover_win32.h"

#include "qoverdlg.h"
#include "qresultwidget.h"
#include "qdownloadwidget.h"
#include "qsettingdlg.h"

#include "shareobj.h"
#include "cfgreader.h"
#include "qover_win32.h"
#include <qaccel.h>
//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////
//! iуXe[^X\pvOX
class QMyProgressBar :public QProgressBar
{
public:
	 QMyProgressBar( QWidget * parent=0, const char * name=0, WFlags f=0 )
		 :QProgressBar(parent, name, f)
	{
		m_bReset=true;
	}

	//! eLXgݒ
	void showText(char* szStr)
	{
		if(szStr)
		{
			m_str=szStr;
		}
	}
protected:
	//! eLXg\
	bool setIndicator ( QString & indicator, int progress, int totalSteps ) 
	{
		bool bRet=m_bReset;
		m_bReset=false;
		indicator=m_str;
		return bRet;
	}
	bool m_bReset;
	QString m_str;
};

//! C_CAO\z
QOverDlg::QOverDlg( QWidget *parent, const char *name )
: QMainWindow(parent, name, 0)
{
	m_pObj		=0;

	QVBoxLayout* pvbox = new QVBoxLayout(this, 3);
	{	// CIuWFNgݒ

		QHBoxLayout* psbox = new QHBoxLayout(this, 3);

		m_pbtSetting =new QPushButton( this );
		m_pbtSetting->setText("Setting(&G)");
		m_pbtSetting->setAccel(CTRL+'G');
		psbox->addWidget(m_pbtSetting);

		m_pprgParcent=new QMyProgressBar(this);
		m_pprgParcent->setIndicatorFollowsStyle(FALSE);
		m_pprgParcent->setTotalSteps(100);
		psbox->addWidget(m_pprgParcent);
		pvbox->addLayout(psbox);	

		m_pbtPlay =new QPushButton( this );
		m_pbtPlay->setText("null");
		m_pbtPlay->setMinimumWidth(100);
		psbox->addWidget(m_pbtPlay);
	}

	{	// TABݒ
		m_pTabs = new QTabWidget( this );
		pvbox->addWidget(m_pTabs);

		// TAB
		m_pwResult		= new QResultWidget(this);
		m_pwDownload	= new QDownloadWidget(this);

		m_pTabs->addTab(m_pwResult  ,"Search");
		m_pTabs->addTab(m_pwDownload,"Download");

		// Dialog
		m_pdSetting		= 0;
	}    

	QAccel* pKey=new QAccel(this);
	pKey->connectItem(pKey->insertItem(Qt::Key_Left+CTRL,   100),this,SLOT(pageL()));
	pKey->connectItem(pKey->insertItem(Qt::Key_Right+CTRL,  101),this,SLOT(pageR()));

	m_ptimer = new QTimer( this );
    m_ptimer->start(500); // ^C}[쓮
	connect( m_ptimer, SIGNAL(timeout()),this, SLOT(timerDone()) );	
}

//! fXgN^
QOverDlg::~QOverDlg()
{
	m_pwDownload->save();
	delete m_pObj;
}

void QOverDlg::pageL(void)
{
	((QTabWidget*)m_pTabs)->showPage(m_pwResult);
}

void QOverDlg::pageR(void)
{
	((QTabWidget*)m_pTabs)->showPage(m_pwDownload);
}

void QOverDlg::closeEvent( QCloseEvent *e ){
    e->accept();
}

void QOverDlg::timerDone()
{
	if (m_pObj==0)
	{
		// LIuWFNg쐬
		m_pObj= new shareObj;

		m_pwResult->setObj(m_pObj);
		m_pwDownload->setObj(m_pObj);

		{	// Cxg
			connect( m_pbtSetting, SIGNAL( clicked() ), this, SLOT( onSetting() ) );
			connect( m_pbtPlay   , SIGNAL( clicked() ), this, SLOT( onPlay() ) );
		}
	}
	else
	{
		char* p	=0;
		int nRev=0;
		int ret=m_pwDownload->timeUpdate(&nRev);		
		if(nRev<0)
		{	// G[l
			p =new char[100];
			sprintf(p,"error=%d",nRev);
		}
		
		progress(ret,p);			
		delete p;

		m_pwResult->timeUpdate();
	}	
}

//! ݒ_CAOJ
void QOverDlg::onSetting()
{
	if(isThread())
	{	// ȂXbhNĂꍇ삳Ȃ
		return;
	}

	if(m_pObj)
	{
		if(!m_pdSetting)
		{
			m_pdSetting	= new QSettingDlg(this);
			m_pdSetting->setObj(m_pObj);
		}
		m_pdSetting->show();
	}
}

//! Đ_CAOJ
void QOverDlg::onPlay()
{
	if(isThread())
	{	// ȂXbhNĂꍇ삳Ȃ
		return;
	}
}

QListView* QOverDlg::ref_list()
{
	return m_pwDownload->ref_list();
}

void QOverDlg::progress(int n,char* psz)
{
	m_pprgParcent->showText(psz);

	if (n<0)
	{	
		m_pprgParcent->setProgress(1);
		n=0;
	}
	m_pprgParcent->setProgress(n);		
}

int QOverDlg::isThread()
{
	if(m_pwResult->isThread())
	{
		return 1;
	}
	if(m_pwDownload->isThread())
	{
		return 2;
	}
	return 0;
}
