// searchThread.cpp: searchThread NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "qover_win32.h"

#include "searchthread.h"
#include "urlobj.h"
#include "stringhelper.h"
#include "shareobj.h"
#include <qstatusbar.h>

searchData::searchData()
{
	for(int n=0;n<6;n++)
	{
		m_pqcs[n]=new QCString;
	}
}

searchData::~searchData()
{
	for(int n=0;n<6;delete m_pqcs[n++]);
}

void searchData::add(int n,const char* psz)
{
	if(psz)
	{
		*m_pqcs[n]=psz;
	}
	else
	{
		*m_pqcs[n]=" ";	
	}
}

const char* searchData::ref(int n)
{
	return *m_pqcs[n];
}

#ifdef WIN32
static unsigned int _stdcall threadcaller(void* pv)
{
	((searchThread*)pv)->thread();
	((searchThread*)pv)->end();
	_endthreadex(0);
	return 0;
}
#else
#include <pthread.h>
static void* threadcaller(void* pv)
{
	((searchThread*)pv)->thread();
	((searchThread*)pv)->end();
	return 0;
}
#endif

searchThread::searchThread(QListView* pList, QStatusBar* pBar,shareObj* pObj, const char* str,int nEngine, int nMode, int nPage)
: _baseThread(pList,pObj)
{
	m_pBar		=pBar;
	m_nEngine	=nEngine;
	m_nMode		=nMode;
	m_nPage		=nPage;
	m_nDataNum	=-1;

	m_pDataList	=new QArray<searchData*>;
	m_pqcsSearch=new QCString(str);
	m_pHttp		=new httpHelper;

	m_pHttp->setTimeout(m_pObj->ref_Timeout(1));
	m_pHttp->setUserAgent(m_pObj->ref_UA_String());
	m_pHttp->setProxy(m_pObj->ref_Proxy(),m_pObj->ref_Port());
	m_pHttp->setUser(m_pObj->ref_Name(),m_pObj->ref_Pass());

	m_pBar->message("start searching ...");
	fputs("--------start search thread--------\n",stderr);
	fprintf(stderr,"Timeout= %d\n"  ,m_pObj->ref_Timeout(1));
	fprintf(stderr,"UserAgent= %s\n",m_pObj->ref_UA_String());
	fprintf(stderr,"Proxy= %s\n"    ,m_pObj->ref_Proxy());
	fprintf(stderr,"Port= %d\n"     ,m_pObj->ref_Port());
	fprintf(stderr,"ID= %s\n"       ,m_pObj->ref_Name());
	fprintf(stderr,"Password= %s\n" ,m_pObj->ref_Pass());

#ifdef WIN32
	m_hThread=(void*)_beginthreadex(NULL,0,threadcaller,this,0,0);
#else
	pthread_t* thread =new pthread_t;
	pthread_create(thread, 0, threadcaller, this);
	m_hThread=(void*)thread;
#endif
}

searchThread::~searchThread()
{
	delete m_pHttp;

	for(int n=0;n<=(int)m_nDataNum;n++)
	{
		searchData* p=	m_pDataList->at(n);
		m_pList->insertItem(new QListViewItem( m_pList,"H", QString::FROM_TR(p->ref(0)), QString::FROM_TR(p->ref(1)),QString::FROM_TR(p->ref(2)),QString::FROM_TR(p->ref(3)),QString::FROM_TR(p->ref(4)),QString::FROM_TR(p->ref(5))));
		delete p;
	}

	char str[260];
	if(m_nRet<0)
	{
		sprintf(str,"network error =%d",m_nRet);
	}
	else if (m_nDataNum+1>0)
	{
		sprintf(str,"success (%d data found.)",m_nDataNum+1);
	}
	else
	{
		sprintf(str,"not data found.");	
	}
	m_pBar->message(str);			

	delete m_pDataList;
	delete m_pqcsSearch;
	fputs("--------end search thread--------\n",stderr);
}

unsigned int searchThread::thread()
{
	eEngine nMTable[]={search_name,search_user,search_direct};
	eEngine nMOTable[]={search_name_option,search_user_option,search_direct_option};

	engineQov* pQov=m_pObj->ref_Engine(m_nEngine);
    if(2>pQov->length(nMTable[m_nMode]))
	{	// T|[gĂȂ
		m_nRet=-98;
		return -98;
	}
	fprintf(stderr,"engine = %s\n",pQov->ref(engine_title));
	fprintf(stderr,"mode = %d\n",m_nPage);		
	
	if( (pQov->toInt(nMOTable[m_nMode]))==1 )
	{	// IvVĂƂ̂URLϊs
		((QCStringEx*)m_pqcsSearch)->tourl();
		fprintf(stderr,"option = 1\n");
	}
	else
	{
		fprintf(stderr,"option = 0\n");		
	}

	// y[WXebv̐ݒ
	QCString qcsAllPath;
	int nPage=pQov->toInt(search_start)+m_nPage*pQov->toInt(search_step);
	q_print(&qcsAllPath,pQov->ref(nMTable[m_nMode]),(const char*)*m_pqcsSearch,nPage);


	fprintf(stderr,"search url = %s\n",(const char*)qcsAllPath);		
	if (0<=(m_nRet=m_pHttp->connectEx(qcsAllPath)))
	{	// htmlobt@O
		m_nAll = m_pHttp->allDataSize();
		while( m_nBreak==0 && 0==(m_nRet=m_pHttp->bufferring()) )
		{
			m_nCurrent=m_pHttp->readDataSize();
		}
	}
	if (m_nRet<0)
	{
		return m_nRet;	
	}

	QCString qcstop;
	QCString qcsid;
	QCString qcstitle;
	QCString qcsuser;
	QCString qcsimage;
	QCString qcstime;
	QCString qcsnext;

	int nStep[]	={find0_top-find0_top,find1_top-find0_top,find2_top-find0_top};
	eEngine top		=(eEngine)(find0_top	+nStep[m_nMode]);
	eEngine top_	=(eEngine)(find0_top_	+nStep[m_nMode]);
	eEngine title	=(eEngine)(find0_title	+nStep[m_nMode]);
	eEngine title_	=(eEngine)(find0_title_	+nStep[m_nMode]);
	eEngine user	=(eEngine)(find0_user	+nStep[m_nMode]);
	eEngine user_	=(eEngine)(find0_user_	+nStep[m_nMode]);
	eEngine image	=(eEngine)(find0_image	+nStep[m_nMode]);
	eEngine image_	=(eEngine)(find0_image_	+nStep[m_nMode]);
	eEngine time	=(eEngine)(find0_time	+nStep[m_nMode]);
	eEngine time_	=(eEngine)(find0_time_	+nStep[m_nMode]);
	eEngine id		=(eEngine)(find0_id		+nStep[m_nMode]);
	eEngine id_		=(eEngine)(find0_id_	+nStep[m_nMode]);

	char* pTable[7]={0,0,0,0,0,0,0};
	pTable[0]=q_findstring(&qcstop,m_pHttp->refBuffer(),pQov->ref(top),pQov->ref(top_));
	while( m_nBreak==0 && pTable[0])
	{
		pTable[1]=q_findstring(&qcstitle,pTable[0],pQov->ref(title),pQov->ref(title_));
		pTable[2]=q_findstring(&qcsuser ,pTable[0],pQov->ref(user) ,pQov->ref(user_) );
		pTable[3]=q_findstring(&qcsimage,pTable[0],pQov->ref(image),pQov->ref(image_));
		pTable[4]=q_findstring(&qcstime ,pTable[0],pQov->ref(time) ,pQov->ref(time_) );
		pTable[5]=q_findstring(&qcsid   ,pTable[0],pQov->ref(id)   ,pQov->ref(id_)   );
		pTable[6]=q_findstring(&qcsnext ,pTable[0],pQov->ref(top)  ,pQov->ref(top_)  );

		for(int k=1;k<6;k++)
		{
			if( pTable[6] && pTable[6]<pTable[k])
			{
				pTable[k]=0;
			}
		}
		pTable[0]=pTable[6];

		((QCStringEx*)&qcstitle)->tostring();

		// ̕ϐ̏l-1
		m_nDataNum++;
		if((int)m_pDataList->size()<=m_nDataNum)
		{
			m_pDataList->resize(m_pDataList->size()+_MAX_QOV_);
		}
		searchData* p=new searchData;
		p->add(0,qcstitle);
		p->add(1,qcstime);
		p->add(2,qcsuser);
		p->add(3,qcsid);
		p->add(4,pQov->ref(engine_id));
		p->add(5,qcsimage);
		m_pDataList->at(m_nDataNum)=p;
	}

	return 0;
}

