// stringhelper.cpp: stringhelper NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////
#include "stringhelper.h"
#include "qover_win32.h"

void gethostip(char* pip ,const char* pname)
{
	struct hostent *hostent;
	struct in_addr inaddr;
	
#ifdef WIN32
	WSADATA wsaData;
	WSAStartup(MAKEWORD(2,0), &wsaData);
#endif
	
	pip[0]=0;
	hostent = gethostbyname(pname);
	if (hostent)
	{
#ifdef WIN32
		inaddr.S_un.S_addr = **(unsigned int **)(hostent->h_addr_list);
#else
		inaddr.s_addr = **(unsigned int **)(hostent->h_addr_list);
#endif
		strcpy(pip,inet_ntoa(inaddr));
	}
#ifdef WIN32
	WSACleanup();
#endif
}

void spliturl(char* purl, char* pname, const char* psrc)
{
	char* p=strchr(&psrc[7],'/');
	memcpy(purl,psrc,p-psrc);
	purl[p-psrc]='\0';
	strcpy(pname,p);
}

void q_utf8tojis(QCString* pqcsdst, QCString* pqcssrc)
{
#ifdef WIN32
	*pqcsdst="";

	int size = MultiByteToWideChar(CP_UTF8,0,*pqcssrc,-1,NULL,0);
	unsigned short* pUni=new unsigned short[size+2];
	memset(pUni,0,(size+2)*sizeof(unsigned short));
	size = MultiByteToWideChar(CP_UTF8,0,*pqcssrc,-1,pUni,size+1);
	if (size > 0)
	{	
		size = WideCharToMultiByte(CP_ACP,0,pUni,-1,NULL,0,NULL,NULL);
		char* p=new char[size+2];
		size = WideCharToMultiByte(CP_ACP,0,pUni,-1,p,size+1,NULL,NULL);
		p[size+1]='\0';
		*pqcsdst=p;
		delete [] p;
	}

	delete [] pUni;	
#else
	*pqcsdst=*pqcssrc;
#endif
}

void q_jistoutf8(QCString* pqcsdst, QCString* pqcssrc)
{
#ifdef WIN32
	*pqcsdst="";

	int size = MultiByteToWideChar(CP_ACP,0,*pqcssrc,-1,NULL,0);
	unsigned short* pUni=new unsigned short[size+2];
	memset(pUni,0,(size+2)*sizeof(unsigned short));
	size = MultiByteToWideChar(CP_ACP,0,*pqcssrc,-1,pUni,size+1);
	if (size > 0)
	{	
		size = WideCharToMultiByte(CP_UTF8,0,pUni,-1,NULL,0,NULL,NULL);
		char* p=new char [size+2];
		size = WideCharToMultiByte(CP_UTF8,0,pUni,-1,p,size+1,NULL,NULL);
		p[size+1]='\0';
		*pqcsdst=p;
		delete [] p;
	}

	delete [] pUni;	
#else
	// |C^̃Rs[
	*pqcsdst=*pqcssrc;
#endif
}

void q_urlencode(QCString* pqcsdst, QCString* pqcssrc)
{
	int i=0;
	int j=0;
	static char table[]={"0123456789ABCDEF"};

	pqcsdst->resize(pqcssrc->length()*3+3);
	char* pdst=pqcsdst->data();
	char* psrc=pqcssrc->data();

	while(psrc[i])
	{
		pdst[j]=psrc[i];

		if( psrc[i]=='.' || psrc[i]=='-' || psrc[i]=='_' )
		{
		}
		else if( psrc[i]>='0' && psrc[i]<='9' )
		{
		}
		else if( psrc[i]>='a' && psrc[i]<='z' )
		{
		}
		else if( psrc[i]>='A' && psrc[i]<='Z' )
		{
		}
		else if( psrc[i]==' ' )
		{
			pdst[j]='+';
		}
		else
		{
			pdst[j++]='%';
			pdst[j++]=table[0xf&(psrc[i]>>4)];
			pdst[j  ]=table[0xf&(psrc[i])   ];
		}
		i++;
		j++;		
	}
	pdst[j]='\0';
}

char* q_findstring(QCString* pqcsdst,char* src,const char* start,const char* end)
{
	*pqcsdst="";

	fputs("-------find_start------",stderr);
	fputs(start,stderr);
	fputs(end,stderr);

	char* top=strstr(src,start);
	if (top==0)
	{
		fputs("not found",stderr);
		fputs("--------find_end-------",stderr);
		return 0;
	}
	top=&top[strlen(start)];
	char* bottom=strstr(top,end);
	if (bottom==0 || bottom==top)
	{
		fputs("not found",stderr);
		fputs("--------find_end-------",stderr);
		return 0;
	}
	int nsize=bottom-top;

	char b=top[nsize];
	top[nsize]='\0';
	*pqcsdst=top;
	top[nsize]=b;

	fputs((const char*)*pqcsdst,stderr);
	fputs("--------find_end-------",stderr);
	return bottom;
}	

void QCStringEx::tourl()
{
#ifdef WIN32
	QCString str;
	q_jistoutf8(&str, this);
	q_urlencode(this, &str);
#else
	QCString str;
	q_urlencode(&str, this);
	*((QCString*)this)=str;
#endif
}

void QCStringEx::tostring()
{
	QCString str;
	this->replace( QRegExp("</*b>"), "" );
	this->replace( QRegExp("&nbsp;"), " " );
	this->replace( QRegExp("&quot;"), """" );
	this->replace( QRegExp("&amp;"), "&" );
	this->replace( QRegExp("&lt;"), "<" );
	this->replace( QRegExp("&gt;"), ">" );
	this->replace( QRegExp("&copy;"), "(c)" );
	this->replace( QRegExp("\\r.*"), "" );
	q_utf8tojis(&str, this);
	*((QCString*)this)=str;
}

void q_print(QCString* dst,const char* filter,const char* str,int num)
{
    *dst=filter;
    char numt[32];
    sprintf(numt,"%d",num);
	dst->replace( QRegExp("%s"), str );
	dst->replace( QRegExp("%d"), numt );
}